#!/users/simonh/bin/perl.static.pt -I/users/simonh/src/_sids/src -I/users/simonh/src/_sids/src/Modules -I/users/simonh/src/_sids/src/Wrappers -I/users/simonh/src/_sids/src/Libs

##################!/usr/bin/perl -I/users/simonh/src/_sids/src -I/users/simonh/src/_sids/src/Modules -I/users/simonh/src/_sids/src/Wrappers -I/users/simonh/src/_sids/src/Libs

# -- explicitly set the places looked for Perl modules to ensure only our
#    local, read-only, safe copies are used (above -IPath is overwridden...) :

# @INC = ("../lib/perl5/5.6.1/sun4-solaris",
#         "../lib/perl5/5.6.1", 
#         "../lib/perl5/site_perl/5.6.1/sun4-solaris",
#         "../lib/perl5/site_perl/5.6.1",
#         "../lib/perl5/site_perl/",
#         ".", "./Modules", "./Wrappers", "./Libs", "../../_md5",);
   
use strict;
use Modules_Config;
use SID_Config;
use SIDS;


select STDOUT;
$| = 1;

##my $config   = SID_Config->new(SLEEP_TIME => 3600);
my $config     = SID_Config->new(SLEEP_TIME => 5);
my $modsconf   = Modules_Config->new();

my $me         = SIDS->new();
my @id_modules = ();

print "\n Hello from Sid's Intrusion Detection System!";
print "\n ";

foreach (@{$modsconf->modules_to_use()}) {
    print "\n Gonna use module :  $_";
    require "Modules/$_.pm";
    my $mod = $_->new($config, $modsconf);
    push(@id_modules, $mod);
    print "\n  ...got module :  $_ ($mod)";
  }

while(1) {
    foreach my $idm (@id_modules) {
        if ($idm->time_to_run()) {
            $idm->run($me); 
          }
      }
    print "\n ";
    print "\n Sleeping for " . $config->sleep_time() . " seconds...";
    sleep($config->sleep_time());
  }



